import QtQuick 2.12
import QtQuick.Controls 2.12

ApplicationWindow {
    visible: true
    width: 640
    height: 480
    property real startTime

    SequentialAnimation {
        id: anim

        NumberAnimation {
            duration: 5000
        }
        ScriptAction {
            script: leftRect.visible = true
        }
    }
    Timer {
        id: timer
        interval: 5000
        repeat: false
        onTriggered: rightRect.visible = true
    }

    Text {
        id: leftClock
        anchors.horizontalCenter: leftRect.horizontalCenter
        Timer {
            running:true
            repeat:true
            interval: 1
            onTriggered: {
                if (anim.running)
                    leftClock.text = Date.now() - startTime
            }
        }
    }
    Text {
        id: rightClock
        anchors.horizontalCenter: rightRect.horizontalCenter
        Timer {
            running:true
            repeat:true
            interval: 1
            onTriggered: {
                if (timer.running)
                    rightClock.text = Date.now() - startTime
            }
        }
    }

    Rectangle {
        id: leftRect
        anchors.top: leftClock.bottom
        anchors.left: parent.left
        anchors.right: parent.horizontalCenter
        anchors.margins: 8
        height: 200
        color: "red"
    }
    Rectangle {
        id: rightRect
        anchors.top: rightClock.bottom
        anchors.right: parent.right
        anchors.left: parent.horizontalCenter
        anchors.margins: 8
        width: 200
        height: 200
        color: "red"
    }

    Button {
        text: "Start"
        anchors.bottom: parent.bottom
        anchors.horizontalCenter: parent.horizontalCenter
        onClicked: {
            startTime = Date.now()
            leftRect.visible = false
            rightRect.visible = false
            timer.start()
            anim.start()
        }
    }
}
